MODULE MODE_BIN_PAR
    ! Modules
    USE RUNTIME_PARAMETERS
    USE MODES
    USE RTPS

    IMPLICIT NONE
    TYPE(MODE) :: BIN_PAR

    TYPE(RTP_CHAR), TARGET  ::  INPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='input.par',                  &
                    KEYWORD='INPUT_FILENAME',           &
                    DESCRIPTION='')
  
  
    TYPE(RTP_CHAR), TARGET  ::  OUTPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='output.par',                  &
                    KEYWORD='OUTPUT_FILENAME',           &
                    DESCRIPTION='')
  
  
    TYPE(RTP_INTG), TARGET  ::  BIN_FACTOR  =               &
        RTP_INTG(   VALUE=2,                  &
                    KEYWORD='BIN_FACTOR',           &
                    DESCRIPTION='')
  
  
    TYPE(RTP_LOGI), TARGET  ::  UNBIN  =               &
        RTP_LOGI(   VALUE=.FALSE.,                  &
                    KEYWORD='UNBIN',           &
                    DESCRIPTION='')
  
CONTAINS

SUBROUTINE MODE_BIN_PAR_INIT_AND_RUN
    IMPLICIT NONE
    ! Intialise the mode
    CALL BIN_PAR%INIT(COMMAND='BIN_PAR',SUBROUTINE=MODE_BIN_PAR_SLAVE,SHORT_DESCRIPTION='Add description here')

    ! Add RTPs to the mode
    CALL BIN_PAR%ADD_RTP(INPUT_FILENAME)
    CALL BIN_PAR%ADD_RTP(OUTPUT_FILENAME)
    CALL BIN_PAR%ADD_RTP(BIN_FACTOR)
    CALL BIN_PAR%ADD_RTP(UNBIN)

    ! Run the mode
    CALL BIN_PAR%RUN()


END SUBROUTINE MODE_BIN_PAR_INIT_AND_RUN

SUBROUTINE MODE_BIN_PAR_SLAVE
    USE FREALIX_PARAMETERS
    IMPLICIT NONE
    ! Variables


    ! Start work
    CALL FREALIX2_PAR_BIN(INPUT_FILENAME%VALUE,OUTPUT_FILENAME%VALUE,BIN_FACTOR%VALUE,UNBIN%VALUE)


END SUBROUTINE MODE_BIN_PAR_SLAVE

END MODULE MODE_BIN_PAR
