MODULE MODE_CONVOLVE
    USE MODES
    USE RTPS
    IMPLICIT NONE
    TYPE(MODE) :: CONVOLVE

    TYPE(RTP_CHAR), TARGET  ::  INPUT_FILENAME_1  =               &
        RTP_CHAR(   VALUE='input1.mrc',                  &
                    KEYWORD='INPUT_FILENAME_1',           &
                    DESCRIPTION='')


    TYPE(RTP_CHAR), TARGET  ::  INPUT_FILENAME_2  =               &
        RTP_CHAR(   VALUE='input2.mrc',                  &
                    KEYWORD='INPUT_FILENAME_2',           &
                    DESCRIPTION='')


    TYPE(RTP_CHAR), TARGET  ::  OUTPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='output.mrc',                  &
                    KEYWORD='OUTPUT_FILENAME',           &
                    DESCRIPTION='')
CONTAINS

SUBROUTINE MODE_CONVOLVE_INIT_AND_RUN
    IMPLICIT NONE
    ! Intialise the mode
    CALL CONVOLVE%INIT(COMMAND='CONVOLVE',SUBROUTINE=MODE_CONVOLVE_SLAVE,SHORT_DESCRIPTION='Add description here')

    ! Add RTPs to the mode
    CALL CONVOLVE%ADD_RTP(INPUT_FILENAME_1)
    CALL CONVOLVE%ADD_RTP(INPUT_FILENAME_2)
    CALL CONVOLVE%ADD_RTP(OUTPUT_FILENAME)

    ! Run the mode
    CALL CONVOLVE%RUN()
END SUBROUTINE MODE_CONVOLVE_INIT_AND_RUN

SUBROUTINE MODE_CONVOLVE_SLAVE
    USE RUNTIME_PARAMETERS
    USE IMAGES
    IMPLICIT NONE
    ! Variables
    TYPE(IMAGE)     ::  IMG1, IMG2


    ! Start work
    CALL READ_FROM_DISK(IMG1,INPUT_FILENAME_1%VALUE)
    CALL READ_FROM_DISK(IMG2,INPUT_FILENAME_2%VALUE)
    CALL FWD_FT(IMG1)
    CALL FWD_FT(IMG2)
    CALL SHIFT_REAL_SPACE_ORIGIN(IMG1)
    CALL SHIFT_REAL_SPACE_ORIGIN(IMG2)
    IMG1%complex_values = IMG1%complex_values * IMG2%complex_values
    CALL SHIFT_REAL_SPACE_ORIGIN(IMG1)
    CALL BWD_FT(IMG1)
    CALL WRITE_TO_DISK(IMG1,OUTPUT_FILENAME%VALUE)

END SUBROUTINE MODE_CONVOLVE_SLAVE

END MODULE MODE_CONVOLVE
