MODULE MODE_DENSITY_HISTOGRAM
    USE MODES
    USE RTPS
    IMPLICIT NONE
    TYPE(MODE) :: DENSITY_HISTOGRAM

    TYPE(RTP_CHAR), TARGET  ::  INPUT_3D_MODEL  =               &
        RTP_CHAR(   VALUE='model3d.mrc',                  &
                    KEYWORD='',           &
                    DESCRIPTION='')


    TYPE(RTP_CHAR), TARGET  ::  OUT_NAME  =               &
        RTP_CHAR(   VALUE='none',                  &
                    KEYWORD='OUT_NAME',           &
                    DESCRIPTION='')
CONTAINS

SUBROUTINE MODE_DENSITY_HISTOGRAM_INIT_AND_RUN
    ! Intialise the mode
    CALL DENSITY_HISTOGRAM%INIT(COMMAND='DENSITY_HISTOGRAM',SUBROUTINE=MODE_DENSITY_HISTOGRAM_SLAVE,&
                                SHORT_DESCRIPTION='Add description here')

    ! Add RTPs to the mode
    CALL DENSITY_HISTOGRAM%ADD_RTP(INPUT_3D_MODEL)
    CALL DENSITY_HISTOGRAM%ADD_RTP(OUT_NAME)

    ! Run the mode
    CALL DENSITY_HISTOGRAM%RUN()
END SUBROUTINE MODE_DENSITY_HISTOGRAM_INIT_AND_RUN

SUBROUTINE MODE_DENSITY_HISTOGRAM_SLAVE
    USE IMAGEFILES
    USE IMAGES
    IMPLICIT NONE
    INTEGER,ALLOCATABLE :: HISTOGRAM(:)
    REAL,ALLOCATABLE :: BIN_BOUNDARIES(:)

    TYPE(IMAGEFILE) :: MODEL_FILE
    TYPE(IMAGE) :: MODEL_3D


    CALL MODEL_FILE%INIT(INPUT_3D_MODEL%VALUE)
    call model_3d%ReadFromDisk(MODEL_FILE,read_volume_not_slice=.true.)
    CALL MODEL_FILE%CLOSE()


    CALL MODEL_3D%ComputeHistogram(HISTOGRAM, BIN_BOUNDARIES, BIN_CONDENSE_OUTLIERS=.FALSE., PRINT=.TRUE.)

END SUBROUTINE MODE_DENSITY_HISTOGRAM_SLAVE

END MODULE MODE_DENSITY_HISTOGRAM
