!>  \brief  Mode to shift the origin of an image from the top left corner to the center
MODULE MODE_ORIGIN_TO_CENTER
    ! Modules
    USE MODES
    USE RTPS
    IMPLICIT NONE
    TYPE(MODE) :: ORIGIN_TO_CENTER

    TYPE(RTP_CHAR), TARGET  ::  INPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='input',                  &
                    KEYWORD='INPUT_FILENAME',           &
                    DESCRIPTION='Parameter file')


    TYPE(RTP_CHAR), TARGET  ::  OUTPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='output',                  &
                    KEYWORD='OUTPUT_FILENAME',           &
                    DESCRIPTION='Reconstruction to project')

CONTAINS

SUBROUTINE MODE_ORIGIN_TO_CENTER_INIT_AND_RUN
    ! Intialise the mode
    CALL ORIGIN_TO_CENTER%INIT(COMMAND='ORIGIN_TO_CENTER',SUBROUTINE=MODE_ORIGIN_TO_CENTER_SLAVE,   &
                                SHORT_DESCRIPTION='Add description here')

    ! Add RTPs to the mode
    CALL ORIGIN_TO_CENTER%ADD_RTP(INPUT_FILENAME)
    CALL ORIGIN_TO_CENTER%ADD_RTP(OUTPUT_FILENAME)

    ! Run the mode
    CALL ORIGIN_TO_CENTER%RUN()
END SUBROUTINE MODE_ORIGIN_TO_CENTER_INIT_AND_RUN


SUBROUTINE MODE_ORIGIN_TO_CENTER_SLAVE
    USE RUNTIME_PARAMETERS
    USE IMAGES


    IMPLICIT NONE
    ! Variables
    TYPE(IMAGE) ::  IMGIN


    ! Start work
    CALL READ_FROM_DISK(IMGIN,INPUT_FILENAME%VALUE)

    CALL SHIFT_REAL_SPACE_ORIGIN(IMGIN)

    CALL WRITE_TO_DISK(IMGIN,OUTPUT_FILENAME%VALUE)

END SUBROUTINE MODE_ORIGIN_TO_CENTER_SLAVE

END MODULE MODE_ORIGIN_TO_CENTER
