MODULE MODE_SWAPXY
    ! Modules

    USE MODES
    USE RTPS

    IMPLICIT NONE
    TYPE(MODE) :: SWAPXY

    TYPE(RTP_CHAR), TARGET  ::  INPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='input.mrc',                  &
                    KEYWORD='INPUT_FILENAME',           &
                    DESCRIPTION='')
  
  
    TYPE(RTP_CHAR), TARGET  ::  OUTPUT_FILENAME  =               &
        RTP_CHAR(   VALUE='output.mrc',                  &
                    KEYWORD='OUTPUT_FILENAME',           &
                    DESCRIPTION='')
  
CONTAINS

SUBROUTINE MODE_SWAPXY_INIT_AND_RUN
    IMPLICIT NONE
    ! Intialise the mode
    CALL SWAPXY%INIT(COMMAND='SWAPXY',SUBROUTINE=MODE_SWAPXY_SLAVE,SHORT_DESCRIPTION='Add description here')

    ! Add RTPs to the mode
    CALL SWAPXY%ADD_RTP(INPUT_FILENAME)
    CALL SWAPXY%ADD_RTP(OUTPUT_FILENAME)

    ! Run the mode
    CALL SWAPXY%RUN()
END SUBROUTINE MODE_SWAPXY_INIT_AND_RUN

SUBROUTINE MODE_SWAPXY_SLAVE
    USE RUNTIME_PARAMETERS
    USE IMAGEFILES
    USE IMAGES
    USE IMAGES_ARITHM
    IMPLICIT NONE
    ! Variables
    TYPE(IMAGE)     ::  VOL


    ! Start work
    CALL READ_FROM_DISK(VOL,INPUT_FILENAME%VALUE)
    CALL SWAP_XY(VOL)
    CALL WRITE_TO_DISK(VOL,OUTPUT_FILENAME%VALUE)

END SUBROUTINE MODE_SWAPXY_SLAVE

END MODULE MODE_SWAPXY
