!module handlers
!  use gtk, only: gtk_container_add, gtk_drawing_area_new, gtk_events_pending, gtk&
!  &_main, gtk_main_iteration, gtk_main_iteration_do, gtk_widget_get_window, gtk_w&
!  &idget_queue_draw, gtk_widget_show, gtk_window_new, gtk_window_set_default, gtk&
!  &_window_set_default_size, gtk_window_set_title, TRUE, FALSE, c_null_ptr, c_null_char, &
!  & GTK_WINDOW_TOPLEVEL, GDK_COLORSPACE_RGB, gtk_init, g_signal_connect, &
!  &CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL
!
!  use cairo, only: cairo_arc, cairo_create, cairo_curve_to, cairo_destroy, cairo_&
!  &get_target, cairo_line_to, cairo_move_to, cairo_new_sub_path, cairo_paint, cai&
!  &ro_select_font_face, cairo_set_font_size, cairo_set_line_width, cairo_set_sour&
!  &ce, cairo_set_source_rgb, cairo_show_text, cairo_stroke, cairo_surface_write_t&
!  &o_png
!
!  use gdk, only: gdk_cairo_create, gdk_cairo_set_source_pixbuf
!
!  use gdk_pixbuf, only: gdk_pixbuf_get_n_channels, gdk_pixbuf_get_pixels, gdk_pix&
!  &buf_get_rowstride, gdk_pixbuf_new
!
!  use iso_c_binding
!
!implicit none
!
!integer(c_int) :: run_status = TRUE
!  integer(c_int) :: boolresult
!  logical :: boolevent
!
!  type(c_ptr) :: my_pixbuf
!  character(kind=c_char), dimension(:), pointer :: pixel
!  integer(kind=c_int) :: nch, rowstride, width, height
!  logical :: finished
!
!contains
!  ! User defined event handlers go here
!  function delete_event_test (widget, event, gdata) result(ret) bind(c)
!    use iso_c_binding, only: c_ptr, c_int
!integer(c_int) :: ret
!    type(c_ptr), value :: widget, event, gdata
!    !print *, "Delete_event"
!    run_status = FALSE
!    ret = FALSE
!  end function delete_event_test
!
!  subroutine pending_events_test ()
!    do while(IAND(gtk_events_pending(), run_status) /= FALSE)
!      boolresult = gtk_main_iteration_do(FALSE) ! False for non-blocking
!    end do
!end subroutine pending_events_test
!
!  function expose_event_test (widget, event, gdata) result(ret) bind(c)
!    use iso_c_binding, only: c_int, c_ptr
!implicit none
!integer(c_int) :: ret
!    type(c_ptr), value, intent(in) :: widget, event, gdata
!    type(c_ptr) :: my_cairo_context
!    integer :: cstatus
!
!    my_cairo_context = gdk_cairo_create (gtk_widget_get_window(widget))
!
!    call cairo_set_line_width(my_cairo_context, 1d0)
!    call cairo_set_source_rgb(my_cairo_context, 0d0, 0d0, 1d0)
!    call cairo_move_to(my_cairo_context, 100d0, 50d0)
!    call cairo_line_to(my_cairo_context, 700d0, 700d0)
!    call cairo_stroke(my_cairo_context)
!
!
!    call cairo_set_source_rgb(my_cairo_context, 1d0, 0d0, 0d0)
!    call cairo_set_line_width(my_cairo_context, 3d0)
!    call cairo_move_to(my_cairo_context, 60d0, 0d0)
!    call cairo_curve_to(my_cairo_context, 600d0, 50d0, 135d0, 45d0, 500d0, 500d0)
!    call cairo_stroke(my_cairo_context)
!
!    call gdk_cairo_set_source_pixbuf(my_cairo_context, my_pixbuf, 700d0/4d0, 700d0/4d0)
!    call cairo_paint(my_cairo_context)
!
!    call cairo_set_source_rgb(my_cairo_context, 1d0, 1d0, 0d0)
!    call cairo_set_line_width(my_cairo_context, 2d0)
!    call cairo_move_to(my_cairo_context, 0d0, height/2d0)
!    call cairo_line_to(my_cairo_context, 1d0*width, height/2d0)
!    call cairo_move_to(my_cairo_context, width/2d0+width/12d0, 0d0)
!    call cairo_line_to(my_cairo_context, width/2d0+width/12d0, height*1d0)
!    call cairo_stroke(my_cairo_context)
!
!    call cairo_select_font_face(my_cairo_context, "Times"//c_null_char, CAIRO_FONT_SLANT_NORMAL, &
!                                 & CAIRO_FONT_WEIGHT_NORMAL)
!    call cairo_set_font_size (my_cairo_context, 16d0)
!    call cairo_move_to(my_cairo_context, 200d0, 200d0)
!    call cairo_show_text (my_cairo_context, "Mandelbrot set"//c_null_char)
!
!    call cairo_new_sub_path(my_cairo_context)
!    call cairo_arc(my_cairo_context, 300d0, 300d0, 100d0, 0d0, 3.14159d0)
!    call cairo_stroke(my_cairo_context)
!
!    if (finished) then
!cstatus = cairo_surface_write_to_png(cairo_get_target(my_cairo_context), "cairo.png"//c_null_char)
!      print *, cstatus
!    end if
!call cairo_destroy(my_cairo_context)
!    ret = FALSE
!  end function expose_event_test
!end module handlers

MODULE MODE_TEST
    ! Modules
    USE MODES
    USE RTPS

    IMPLICIT NONE
    TYPE(MODE) :: TEST

    TYPE(RTP_CHAR), TARGET  ::  INPUT_FILE_1  =       &
        RTP_CHAR(   VALUE='test_in',                  &
                    KEYWORD='INPUT_FILE_1',           &
                    DESCRIPTION='')

CONTAINS

SUBROUTINE MODE_TEST_INIT_AND_RUN
    ! Intialise the mode
    CALL TEST%INIT(COMMAND='TEST',SUBROUTINE=MODE_TEST_SLAVE,SHORT_DESCRIPTION='Add description here')

    ! Add RTPs to the mode
    !CALL TEST%ADD_RTP(INPUT_FILE_1)

    ! Run the mode
    CALL TEST%RUN()

END SUBROUTINE MODE_TEST_INIT_AND_RUN


SUBROUTINE MODE_TEST_SLAVE
    USE IMAGES
    USE IMAGEFILES
    USE IMAGES_ARITHM
    USE ROTATION_MATRICES
    IMPLICIT NONE
    ! Variables

!    ! Create large test image
!	print *, 'generating large test image'
!    TEST_LARGE%logical_dimensions = (/ 5120,5120,1 /)
!    CALL IMAGE_ALLOCATE(TEST_LARGE)
!    TEST_LARGE%real_values = 1.0
!    CALL CIRC_MASK(TEST_LARGE,RAD=2000.0)
!    !CALL COSINE_DISC(TEST_LARGE,RAD=2000.0,FALLOFF=20.0,MASK_WITH_AVERAGE=.FALSE.)
!    CALL WRITE_TO_DISK(TEST_LARGE,'test_large.mrc')
!
!    ! Bin in real space
!	print *, 'real space binning'
!    CALL BIN(TEST_LARGE,TEST_BINNED_REAL,10,CORRECT_SHIFT=.FALSE.)
!    CALL WRITE_TO_DISK(TEST_BINNED_REAL,'test_binned_real.mrc')
!
!	! Bin in real space, with shift correction
!	PRINT *, 'real space binning, with shift correction'
!	CALL BIN(TEST_LARGE,TEST_BINNED_REAL,10,CORRECT_SHIFT=.TRUE.)
!	CALL WRITE_TO_DISK(TEST_BINNED_REAL,'test_binned_real_shift.mrc')
!
!    ! Bin in reciprocal space
!	print *, 'reciprocal space cropping'
!    TEST_BINNED_FOURIER = TEST_LARGE
!    CALL FWD_FT(TEST_BINNED_FOURIER)
!    CALL CROP(TEST_BINNED_FOURIER,NEWDIM=(/512,512,1/))
!    CALL BWD_FT(TEST_BINNED_FOURIER)
!    CALL WRITE_TO_DISK(TEST_BINNED_FOURIER,'test_binned_fourier.mrc')
!
!
!    ! Unbin
!	print *, 'unbinning'
!    TEST_SMALL%logical_dimensions = (/ 512,512,1 /)
!    CALL IMAGE_ALLOCATE(TEST_SMALL)
!    TEST_SMALL%real_values = 1.0
!    CALL CIRC_MASK(TEST_SMALL,RAD=180.0)
!    CALL WRITE_TO_DISK(TEST_SMALL,'test_small.mrc')
!    CALL BIN(TEST_SMALL,TEST_UNBINNED,2,UNBIN=.TRUE.,CORRECT_SHIFT=.TRUE.)
!    CALL WRITE_TO_DISK(TEST_UNBINNED,'test_small_unbinned.mrc')
!
!    ! Rotation
!    MATRIX1 = ROTMAT(180.0,0.0,0.0)
!
!    ! Rotate both binned imagesi
!	print *, 'rotation'
!    CALL ROTATE_IMAGE(TEST_BINNED_REAL,TEST_ROT,MATRIX1)
!    CALL WRITE_TO_DISK(TEST_ROT,'test_binned_real_180.mrc')
!    TEST_ROT%real_values = 0.0
!    CALL ROTATE_IMAGE(TEST_BINNED_FOURIER,TEST_ROT,MATRIX1)
!    CALL WRITE_TO_DISK(TEST_ROT,'test_binned_fourier_180.mrc')


    ! Print out sinc stuff
    !CALL TEST_SINC_2D

	!
	!CALL TEST_BIN_ONE_FREQ_AT_A_TIME()

	!CALL TEST_AMYLOID_FOURIER_MASK()

	!CALL SPI_SLICE_SYMMETRY()

	!CALL TEST_AMYLOID_MASK()

	!CALL TEST_3D_SLICES()

	!CALL TEST_GTK()

	!CALL TEST_CROP()

	!CALL TEST_BR_ESTIMATOR_STATS()

	CALL TEST_DRIFT_WEIGHTS()

    !call test_file_io()

    !call test_new_file_io()

END SUBROUTINE MODE_TEST_SLAVE


!subroutine test_new_file_io()
!    use ImageFilesCore
!    implicit none
!    ! Private variables
!    type(ImageFileCore)     ::  myImageFile, myOutputImageFile
!    real,   allocatable     ::  rvalues(:,:,:)
!    integer                 ::  i,j,k
!    integer                 ::  address
!    ! Start work
!
!    call myImageFile%Init('test.mrc')
!    call myOutputImageFile%Init('test2.mrc',dim_x=2,dim_y=2,dim_z=2)
!    call myImageFile%ReadSlicesFromDisk(1,2,rvalues)
!    print *, rvalues
!    address = 0
!    do k=1,size(rvalues,3)
!        do j=1,size(rvalues,2)
!            do i=1,size(rvalues,1)-2
!                address = address + 1
!                rvalues(i,j,k) = rvalues(i,j,k) + address
!            enddo
!        enddo
!    enddo
!    print *, rvalues
!    call myOutputImageFile%WriteSlicesToDisk(1,2,rvalues)
!
!end subroutine test_new_file_io

!subroutine test_file_io()
!    use imagefiles
!    use Images, only : image
!    use images_comparison, only : images_are_equal
!    implicit none
!    !
!    type(imagefile)     ::  imgfile_f, imgfile_c
!    type(image)         ::  img_f, img_c
!    !
!    call imgfile_f%init(filename='test.mrc',intent='in',use_c_io=.false.)
!    call imgfile_c%init(filename='test.mrc',intent='in',use_c_io=.true.)
!    ! read data
!    write(*,'(a)') '**info(test_file_io): about to read image, F style'
!    call imgfile_f%read_image(img_f,print_out_read_speed=.true.)
!    write(*,'(a)') '**info(test_file_io): about to read image, C style'
!    call imgfile_c%read_image(img_c,print_out_read_speed=.true.)
!    ! check we got the same result
!    if (images_are_equal(img_f,img_c)) then
!        write(*,'(a)') '**info(test_file_io): images are the same'
!    else
!        write(*,'(a)') '**ERROR(test_file_io): images are NOT the same'
!    endif
!    ! close files
!    call imgfile_f%close()
!    call imgfile_c%close()
!end subroutine test_file_io


SUBROUTINE TEST_DRIFT_WEIGHTS()
    use Images
    use Globals, only : pi
    IMPLICIT NONE
    ! Variables
    TYPE(IMAGE) ::  IMG
    REAL        ::  DRIFT_X,DRIFT_Y, ORIGIN(3)
    REAL        ::  DRIFT,DRIFT_RAD,SPA_FREQ,DRIFT_WEIGHT
    REAL        ::  X,Y,XX,YY
    INTEGER     ::  I,J
    ! Start work
    CALL IMG%Allocate(DIMS=[3500,3500,1])
    IMG%real_values = 1.0
    DRIFT_X = 3.0
    DRIFT_Y = 1.0

    !
    if (img%is_in_real_space .and. img%origin_at_center) then
        origin = img%physical_address_of_box_center
    else
        origin = [1,1,1]
    endif

    !
    DO J=1,IMG%logical_dimensions(2)
        Y = J-ORIGIN(2)
        YY = Y/IMG%logical_dimensions(2)
        DO I=1,IMG%logical_dimensions(1)
            X = I-ORIGIN(1)
            XX = X/IMG%logical_dimensions(1)
            !
            SPA_FREQ = SQRT(XX**2+YY**2)
            DRIFT = XX * DRIFT_X + YY * DRIFT_Y
            IF (SPA_FREQ .EQ. 0.0) THEN
                DRIFT = 0.0
            ELSE
                DRIFT = DRIFT / SPA_FREQ
            ENDIF
            DRIFT_RAD = DRIFT * 2.0 * PI * SPA_FREQ ! this is product Tv in my notes 10-Jul-2013 (Alexis)
            IF (ABS(DRIFT_RAD) .GT. 0.00001) THEN
                DRIFT_WEIGHT = SQRT(SIN(DRIFT_RAD)**2 +(1 - COS(DRIFT_RAD))**2)
                DRIFT_WEIGHT = DRIFT_WEIGHT / ABS(DRIFT_RAD)
                IMG%real_values(I,J,1)=DRIFT_WEIGHT
            ENDIF
        ENDDO
    ENDDO

    CALL WRITE_TO_DISK(IMG,'drift_weights.mrc')

END SUBROUTINE TEST_DRIFT_WEIGHTS


!>  \brief  Study the statistics of the unbiased SNR estimator from Bershad & Rockmore
SUBROUTINE TEST_BR_ESTIMATOR_STATS()
    use Images
    USE FSCS, ONLY : COMPUTE_FSC
    USE RUNTIME_PARAMETERS, ONLY : AVAILABLE_LUN
    IMPLICIT NONE
    ! Private variables
    TYPE(IMAGE)         ::  NOISY(2)
    INTEGER, PARAMETER  ::  NUM_TESTS = 1000
    INTEGER, PARAMETER  ::  DIMS(3) = (/128,128,128/)
    REAL                ::  SNR = 1.0
    INTEGER             ::  CURRENT_TEST, I
    REAL, ALLOCATABLE   ::  CURRENT_FSC(:), ALL_FSCS(:,:)
    INTEGER             ::  CSV_LUN
    ! Start work

    ! Allocate memory for the images
    DO I=1,2
        CALL NOISY(I)%Allocate(DIMS=DIMS)
    ENDDO

    ! Loop over tests
    WRITE(*,'(A)') '**info(TEST_BR_ESTIMATOR_STATS): running tests...'
    DO CURRENT_TEST=1,NUM_TESTS
        WRITE(*,'(A,I0,A,I0)') '**info(TEST_BR_ESTIMATOR_STATS): on test ', CURRENT_TEST, ' of ', NUM_TESTS
        ! Generate images
        NOISY(1:2)%is_in_real_space   = .true.
        NOISY(1)%real_values = 0.0
        CALL NOISY(1)%AddGaussianNoise(SQRT(SNR),SEED=(CURRENT_TEST-1)*3)
        NOISY(2)%real_values = NOISY(1)%real_values
        CALL NOISY(1)%AddGaussianNoise(1.0,SEED=(CURRENT_TEST-1)*3+1)
        CALL NOISY(2)%AddGaussianNoise(1.0,SEED=(CURRENT_TEST-1)*3+2)
        ! Compute FSC
        CALL NOISY(1)%ForwardFT()
        CALL NOISY(2)%ForwardFT()
        CALL COMPUTE_FSC(NOISY(1),NOISY(2),CURRENT_FSC)
        ! Allocate memory for the FSCs
        IF (.NOT. ALLOCATED(ALL_FSCS)) ALLOCATE(ALL_FSCS(SIZE(CURRENT_FSC),NUM_TESTS))
        ! Store current FSC
        ALL_FSCS(:,CURRENT_TEST) = CURRENT_FSC(:)
    ENDDO

    ! Print out the FSCs to a file
    WRITE(*,'(A)') '**info(TEST_BR_ESTIMATOR_STATS): writing out CSV file'
    CSV_LUN = AVAILABLE_LUN()
    OPEN(UNIT=CSV_LUN,FILE='all_fscs.csv',ACTION='WRITE')
    ! Each line of the file will correspond to a spatial frequency
    DO I=1,SIZE(CURRENT_FSC)
        DO CURRENT_TEST=1,NUM_TESTS-1
            WRITE(CSV_LUN,'(F0.6,A)',ADVANCE='NO') ALL_FSCS(I,CURRENT_TEST), ','
        ENDDO
        WRITE(CSV_LUN,'(F0.6)') ALL_FSCS(I,NUM_TESTS)
    ENDDO
    CLOSE(CSV_LUN)

    WRITE(*,'(A)') '**info(TEST_BR_ESTIMATOR_STATS): all done'
END SUBROUTINE TEST_BR_ESTIMATOR_STATS


SUBROUTINE TEST_CROP()
    USE IMAGES
    USE IMAGEFILES
    IMPLICIT NONE
    !
    TYPE(IMAGE)     ::  IMG
    !
    CALL READ_FROM_DISK(IMG,'test.img')
    CALL CROP(IMG,(/512,512,1/))
    CALL WRITE_TO_DISK(IMG,'test2.img')
END SUBROUTINE TEST_CROP

!SUBROUTINE TEST_GTK()
!    USE GTK, ONLY : GTK_INIT
!    use Images, ONLY : IMAGE
!    USE ISO_C_BINDING
!    USE HANDLERS
!    USE IMAGEFILES
!#ifdef __INTEL_COMPILER
!    use ifport, only : sleep
!#endif
!#ifdef NAGFOR_COMPILER
!    use f90_unix_proc, only : sleep
!#endif
!    IMPLICIT NONE
!    ! Private variables
!    TYPE(IMAGE) ::  IMG
!    TYPE(C_PTR) ::  MY_WINDOW, MY_DRAWING_AREA
!    INTEGER     ::  I,J
!    INTEGER     ::  VAL, ADDR
!    ! Start work
!
!    FINISHED = .FALSE.
!    CALL GTK_INIT()
!
!
!    ! Set up the main window
!    WIDTH = 600
!    HEIGHT = 600
!    MY_WINDOW = GTK_WINDOW_NEW(GTK_WINDOW_TOPLEVEL)
!    CALL GTK_WINDOW_SET_DEFAULT_SIZE(MY_WINDOW,WIDTH,HEIGHT)
!    CALL GTK_WINDOW_SET_TITLE(MY_WINDOW,"Testing GTK for Frealix"//C_NULL_CHAR)
!    CALL G_SIGNAL_CONNECT(MY_WINDOW,"delete-event"//c_null_char, C_FUNLOC(DELETE_EVENT_TEST))
!
!    MY_DRAWING_AREA = GTK_DRAWING_AREA_NEW()
!    CALL G_SIGNAL_CONNECT(MY_DRAWING_AREA,"expose-event"//c_null_char,C_FUNLOC(EXPOSE_EVENT_TEST))
!    CALL GTK_CONTAINER_ADD(MY_WINDOW,MY_DRAWING_AREA)
!    CALL GTK_WIDGET_SHOW(MY_DRAWING_AREA)
!
!    CALL GTK_WIDGET_SHOW(MY_WINDOW)
!
!
!    !
!    MY_PIXBUF = GDK_PIXBUF_NEW(GDK_COLORSPACE_RGB, TRUE, 8_C_INT, &
!                               & WIDTH,HEIGHT)
!
!    NCH = GDK_PIXBUF_GET_N_CHANNELS(MY_PIXBUF)
!    ROWSTRIDE = GDK_PIXBUF_GET_ROWSTRIDE(MY_PIXBUF)
!    CALL C_F_POINTER(GDK_PIXBUF_GET_PIXELS(MY_PIXBUF),PIXEL, (/WIDTH*HEIGHT*NCH/))
!
!    ! Initialise
!    DO I=1,(WIDTH*HEIGHT)*NCH,NCH
!        PIXEL(I)   = CHAR(0)    ! R
!        PIXEL(I+1) = CHAR(0)    ! G
!        PIXEL(I+2) = CHAR(0)    ! B
!        PIXEL(I+3) = CHAR(255)  ! A
!    ENDDO
!
!    ! Write image values
!    CALL READ_FROM_DISK(IMG,'test.img')
!    DO J=1,HEIGHT
!        DO I=1,WIDTH
!            ADDR = 1+NCH*((I-1)+(J-1)*WIDTH)
!
!            VAL  = INT(IMG%real_values(I,J,1)/20.0*255.0)
!            PIXEL(ADDR+0) = CHAR(VAL)
!            PIXEL(ADDR+1) = CHAR(VAL)
!            PIXEL(ADDR+2) = CHAR(VAL)
!            PIXEL(ADDR+3) = CHAR(255)
!
!        ENDDO
!    ENDDO
!
!
!    !
!    DO
!        CALL PENDING_EVENTS_TEST()
!        IF (RUN_STATUS == FALSE) EXIT
!        CALL SLEEP(1)
!    END DO
!
!    PRINT *, 'EXITING TEST_GTK'
!
!END SUBROUTINE TEST_GTK

SUBROUTINE TEST_3D_SLICES()
    IMPLICIT NONE


END SUBROUTINE TEST_3D_SLICES

SUBROUTINE TEST_AMYLOID_MASK()
    USE MASKS, ONLY : FOURIER_MASK_INIT_AMYLOID
    use Images
    USE IMAGEFILES
    IMPLICIT NONE
    !
    TYPE(IMAGE) :: M, MOULD
    !
    MOULD%logical_dimensions = [128,128,1]
    CALL FOURIER_MASK_INIT_AMYLOID(M,MOULD,1.163,180.0,6.0)
    CALL WRITE_TO_DISK(M,'dbg_m.mrc')
END SUBROUTINE TEST_AMYLOID_MASK


SUBROUTINE SPI_SLICE_SYMMETRY()
    USE RUNTIME_PARAMETERS, ONLY : FILENAME_LEN
    USE PARSERS, ONLY : GET_REALS_FROM_COLUMN, GET_INTS_FROM_COLUMN
    use Images
    USE ROTATION_MATRICES, ONLY : EULER_TO_ROTMAT, ROTATION_MATRIX
    USE IMAGES_THREED, ONLY : INSERT_SLICE_PUT
    USE INTERPOLATION, ONLY : DEFAULT_INTERPOL_SCHEME
    use ImageFiles
    IMPLICIT NONE
    ! Private variables
    CHARACTER(LEN=FILENAME_LEN),    PARAMETER   ::  SPI_PARAMS_FN           = 'goodparams-cc0200-side001_pol220_178.dat'
    CHARACTER(LEN=FILENAME_LEN),    PARAMETER   ::  SPI_ANGLES_FN           = 'angles-side001_178.dat'
    CHARACTER(LEN=FILENAME_LEN),    PARAMETER   ::  STACK_FN                = 'test_image.mrc'  !'051215_tmv-flo1x-cut-pol220.mrc'
    CHARACTER(LEN=FILENAME_LEN),    PARAMETER   ::  OUTPUT_REC_FN           = '3drec.mrc'
    INTEGER,                        PARAMETER   ::  NUM_SUBUNITS_PER_IMAGE  = 3
    INTEGER,                        PARAMETER   ::  REC_DIM                 = 200
    ! Private variables
    TYPE(IMAGEFILE)             ::  STACK
    REAL,   ALLOCATABLE         ::  SPI_IN_PLANE(:), SPI_X(:), SPI_Y(:), SPI_OUT_OF_PLANE(:), SPI_TWIST(:)
    INTEGER,    ALLOCATABLE     ::  LOC_IN_STACK(:)
    INTEGER                     ::  CURRENT_IMAGE
    TYPE(IMAGE)                 ::  IMG, REC
    REAL(KIND=8)                ::  PHI,THETA,PSI,X,Y
    TYPE(ROTATION_MATRIX)       ::  RMAT
    ! Start work
    WRITE(*,'(A)') '**info(SPI_SLICE_SYMMETRY): entering'

    ! Load spider alignment parameters
    CALL GET_REALS_FROM_COLUMN(SPI_PARAMS_FN,5,SPI_IN_PLANE)
    CALL GET_REALS_FROM_COLUMN(SPI_PARAMS_FN,6,SPI_X)
    CALL GET_REALS_FROM_COLUMN(SPI_PARAMS_FN,7,SPI_Y)
    CALL GET_REALS_FROM_COLUMN(SPI_ANGLES_FN,4,SPI_OUT_OF_PLANE)
    CALL GET_REALS_FROM_COLUMN(SPI_ANGLES_FN,5,SPI_TWIST)
    CALL GET_INTS_FROM_COLUMN(SPI_PARAMS_FN,8,LOC_IN_STACK)

    ! How many images are we dealing with?
    WRITE(*,'(A,I0)') '**info(SPI_SLICE_SYMMETRY): images in parameter file : ', SIZE(SPI_X)

    ! Open the stack file
    CALL STACK%INIT(STACK_FN)
    CALL STACK%PrintInfo()

    ! Initialise the 3D reconstruction volume
    REC%logical_dimensions = [REC_DIM,REC_DIM,REC_DIM]
    CALL IMAGE_ALLOCATE(REC)
    REC%is_in_real_space = .false.

    ! Loop over images
    DO CURRENT_IMAGE=1,1


        ! Grab the Euler angles & shifts for insertion
        PHI   = SPI_TWIST(CURRENT_IMAGE)
        THETA = SPI_OUT_OF_PLANE(CURRENT_IMAGE)
        PSI   = SPI_IN_PLANE(CURRENT_IMAGE)
        X     = SPI_X(CURRENT_IMAGE)
        Y     = SPI_Y(CURRENT_IMAGE)

        ! Write out info
        WRITE(*,'(A,I0,A,I0,A,I0,1X,5(F0.3,1X))')   '**info(SPI_SLICE_SYMMETRY): on image ', CURRENT_IMAGE, ' of ', &
                                                    SIZE(SPI_X), '. Loc, X, Y, in-, out-, twist = ', &
                                                    LOC_IN_STACK(CURRENT_IMAGE), X, Y, &
                                                    PSI, THETA, PHI

        ! Convert
        CALL SPI_TO_FRE(X,Y,PHI,THETA,PSI)

        ! Write out info
        WRITE(*,'(A,I0,A,I0,A,I0,1X,5(F0.3,1X))')   '**info(SPI_SLICE_SYMMETRY): on image ', CURRENT_IMAGE, ' of ', &
                                                    SIZE(SPI_X), '. Loc, X, Y, in-, out-, twist = ', &
                                                    LOC_IN_STACK(CURRENT_IMAGE), X, Y, &
                                                    PSI, THETA, PHI

        ! Read image from the file
        call img%ReadFromDisk(stack,wanted_location=loc_in_stack(current_image))

        ! Resize the image
        CALL CROP(IMG,[REC_DIM,REC_DIM,1])

        ! Add to the 3D reconstruction

        CALL FWD_FT(IMG)
        CALL SHIFT_REAL_SPACE_ORIGIN(IMG)
        CALL PSHIFT_IMAGE(IMG,REAL(X),REAL(Y),0.0)
        RMAT%RMATRIX = EULER_TO_ROTMAT(PHI,THETA,PSI,REVERSE=.TRUE.)
        CALL INSERT_SLICE_PUT(  REC, IMG, RMAT, DEFAULT_INTERPOL_SCHEME() )

    ENDDO   ! End of loop over images


    ! "Finalise" the 3D reconstruction
    CALL SHIFT_REAL_SPACE_ORIGIN(REC)
    CALL BWD_FT(REC)

    ! Write the reconstruction to disk
    CALL WRITE_TO_DISK(REC,OUTPUT_REC_FN)

    ! Close the stack file
    CALL STACK%CLOSE()
END SUBROUTINE SPI_SLICE_SYMMETRY

SUBROUTINE SPI_TO_FRE(X,Y,PHI,THETA,PSI)
    USE ROTATION_MATRICES, ONLY : RADIANS
    IMPLICIT NONE
    REAL(KIND=8),   INTENT(INOUT)   ::  X,Y,PHI,THETA,PSI
    ! Private variables
    REAL(KIND=8) :: PSIR
    REAL(KIND=8) :: X_IN, Y_IN
    !
    X_IN = X
    Y_IN = Y
    !
    PSIR = RADIANS(-PSI)
    X = SIN(PSIR)*Y_IN + COS(PSIR)*X_IN
    Y = COS(PSIR)*Y_IN - SIN(PSIR)*X_IN
    !
    PSI = -PSI + 270.
    !

END SUBROUTINE SPI_TO_FRE

SUBROUTINE TEST_AMYLOID_FOURIER_MASK()
    USE MASKS
    use Images
    IMPLICIT NONE
    !
    TYPE(IMAGE) ::  FMASK
    TYPE(IMAGE) ::  MOULD

    MOULD%logical_dimensions = [300,300,1]
    CALL FOURIER_MASK_INIT_AMYLOID(FMASK,MOULD,PIXEL_SIZE=1.2,FIL_MAX_RAD=180.0,MAX_SPACING_ALIGN=7.0)
END SUBROUTINE TEST_AMYLOID_FOURIER_MASK


SUBROUTINE TEST_BIN_ONE_FREQ_AT_A_TIME()
	USE IMAGES
	USE INTERPOLATION, ONLY : SINC
	IMPLICIT NONE
	!
	TYPE(IMAGE)	::	IMG,IMGOUT,IMG_AMPL
	REAL :: FREQ
	REAL :: SML
	INTEGER, PARAMETER	::	TEST_ADDR(3) = (/18,1,1/)
	INTEGER, PARAMETER	::  IMG_DIM(3) = (/128,128,1/)

	SML = EPSILON(1.0)

	! Create single-frequency image
	IMG%logical_dimensions = IMG_DIM
	CALL IMAGE_ALLOCATE(IMG)
	IMG%complex_values = (0.0,0.0)
	CALL FWD_FT(IMG)
	IMG%complex_values(TEST_ADDR(1),TEST_ADDR(2),TEST_ADDR(3)) = (1.0,0.0)
	CALL BWD_FT(IMG)
	CALL FWD_FT(IMG)
	CALL BWD_FT(IMG)
	CALL WRITE_TO_DISK(IMG,'single_freq.mrc')
    CALL FWD_FT(IMG)
	CALL AMPL(IMG,IMG_AMPL)
	CALL WRITE_TO_DISK(IMG_AMPL,'single_freq_ampl.mrc')


	! Bin & write out
	IF (IMG%IsComplex()) CALL IMG%BackwardFT()
	CALL IMG%BinTo(IMGOUT,2,PRESERVE_CENTER=.FALSE.)
	CALL WRITE_TO_DISK(IMGOUT,'single_freq_bin2.mrc')
	CALL IMGOUT%ForwardFT()
	CALL IMGOUT%ComputeAmplitudes(IMG_AMPL)
	CALL WRITE_TO_DISK(IMG_AMPL,'single_freq_bin2_ampl.mrc')

	FREQ = (REAL(TEST_ADDR(1))-1.)/REAL(IMGOUT%logical_dimensions(1))
	WRITE(*,'(A,5(F0.2,1x))') 'value, ampl of peak in Fourier space; sinc, sinc**2 = ', &
	                                    IMGOUT%complex_values(TEST_ADDR(1),TEST_ADDR(2),TEST_ADDR(3)), &
										CABS(IMGOUT%complex_values(TEST_ADDR(1),TEST_ADDR(2),TEST_ADDR(3))), SINC(FREQ), SINC(FREQ)**2

	! Check: how many pixels in the FT are non-zero?
	IF (IMGOUT%IsReal()) CALL IMGOUT%ForwardFT()
	IF (IMG%IsReal()) CALL IMG%ForwardFT()
   	WRITE(*,'(I0,A)') COUNT(ABS(REAL(IMG%complex_values)) .GT. SML .OR. ABS(AIMAG(IMG%complex_values)) .GT. SML), &
   	                    ' pixels in input image FT are non-zero'
	WRITE(*,'(I0,A)') COUNT(ABS(REAL(IMGOUT%complex_values)) .GT. SML .OR. ABS(AIMAG(IMGOUT%complex_values)) .GT. SML), &
	                    ' pixels in output image FT are non-zero'



END SUBROUTINE

SUBROUTINE TEST_SINC_2D()
    USE ROTATION_MATRICES, ONLY : RADIANS
    USE INTERPOLATION, ONLY : SINC
    USE IMAGES
    IMPLICIT NONE
    INTEGER ::  I,J
    REAL    ::  R
    REAL    ::  PHI
    REAL    ::  X,Y
    REAL    ::  SINC_PRODUCT, SINC_X, SINC_Y,SINC_R
    REAL(KIND=8)    ::  RESULT
    TYPE(IMAGE) ::  IMG_SINC_PRODUCT,IMG_SINC_RADIUS
    REAL, ALLOCATABLE   ::  SINC_PROD_AVROT(:), SINC_RAD_AVROT(:)



    WRITE(*,'(4(A,1X))') 'Radius', 'sinc(x)*sinc(y)', 'sinc(r)', 'sinc^2(r)'
    ! Loop over radius
    DO I=0,100
        R = REAL(I)*.5/100.0
        RESULT = 0.0D0
        ! Loop over angles
        DO J=0,1000
            PHI = REAL(J)*90./1000.
            ! Convert polar to cartesian coordinates
            X = COS(RADIANS(PHI))*R
            Y = SIN(RADIANS(PHI))*R
            ! Compute the value of the kernel
            SINC_X = SINC(X)
            SINC_Y = SINC(Y)
            SINC_PRODUCT = SINC_X * SINC_Y
            RESULT = RESULT + SINC_PRODUCT
        ENDDO ! End loop over angles
        SINC_R = SINC(R)
        WRITE(*,'(4(F0.5,1X))') R, RESULT/1001.0, SINC_R, SINC_R**2
    ENDDO

    ! Generate an image
    IMG_SINC_PRODUCT%logical_dimensions = (/512,512,1/)
    CALL IMG_SINC_PRODUCT%Allocate()
    CALL IMG_SINC_RADIUS%Allocate()
    DO J=1,IMG_SINC_PRODUCT%logical_dimensions(2)
        Y = REAL(J-257)
        DO I=1,IMG_SINC_PRODUCT%logical_dimensions(1)
            X = REAL(I-257)
            R = SQRT(X**2+Y**2)
            IMG_SINC_PRODUCT%real_values(I,J,1) = SINC(X/512.)*SINC(Y/512.)
            IMG_SINC_RADIUS%real_values(I,J,1) = SINC(R/512.)
        ENDDO
    ENDDO
    CALL WRITE_TO_DISK(IMG_SINC_PRODUCT,'test_sinc_prodxy.mrc')
    CALL WRITE_TO_DISK(IMG_SINC_RADIUS,'test_sinc_radius.mrc')
    SINC_PROD_AVROT = IMG_SINC_PRODUCT%Retun1DRotationalAverage()
    SINC_RAD_AVROT = IMG_SINC_RADIUS%Retun1DRotationalAverage()

    WRITE(*,'(3(A,1X))') 'Radius', 'sinc(x)*sinc(y)', 'sinc^2(r)'
    DO I=1,SIZE(SINC_PROD_AVROT)
        WRITE(*,'(3(F0.4,1X))') REAL(I-1)/512.,SINC_PROD_AVROT(I),SINC_RAD_AVROT(I)
    ENDDO


END SUBROUTINE TEST_SINC_2D

END MODULE MODE_TEST
