!>  \brief  Run unit tests
MODULE MODE_UNIT_TESTS
    USE MODES
    USE RTPS
    IMPLICIT NONE
    ! Declare mode object
    TYPE(MODE)  ::  UNIT_TESTS
    ! Declare RTPs
!    TYPE(RTP_CHAR)  ::  OUTPUT_FILENAME =               &
!        RTP_CHAR(   VALUE='output.mrc',                 &
!                    KEYWORD='OUTPUT_FILENAME',          &
!                    DESCRIPTION='Name of output file')
CONTAINS

SUBROUTINE MODE_UNIT_TESTS_INIT_AND_RUN
    ! Initialise the mode
    CALL UNIT_TESTS%INIT(  COMMAND='UNIT_TESTS',              &
                    SUBROUTINE=MODE_UNIT_TESTS_SLAVE,  &
                    SHORT_DESCRIPTION='Run Frealix unit tests')
    ! Add RTPs to the mode
!    CALL BIN%ADD_RTP(OUTPUT_FILENAME)

    ! Run the mode
    CALL UNIT_TESTS%RUN()
END SUBROUTINE MODE_UNIT_TESTS_INIT_AND_RUN

SUBROUTINE MODE_UNIT_TESTS_SLAVE
    ! Modules
    use Images
    USE CTFS, ONLY : CTF_UNIT_TESTS
    USE THREEDS, ONLY : THREED_UNIT_TESTS
    USE FSCS, ONLY : FSC_UNIT_TESTS
    USE DIFFERENTIAL_GEOMETRY, ONLY : SPACE_CURVE_UNIT_TESTS
    USE FMCS, ONLY : FMC_UNIT_TESTS
    USE COOS, ONLY : COOS_UNIT_TESTS
    USE IMAGES_CTF, ONLY : IMAGE_CTF_UNIT_TESTS
    USE HELICES, ONLY : HELIX_UNIT_TESTS
    USE IMAGES_HELICES, ONLY : IMAGES_HELICES_UNIT_TESTS
    USE RUNTIME_PARAMETERS, ONLY : TERMINATE
    IMPLICIT NONE

    ! Variables



    ! Start work
    CALL IMAGES_HELICES_UNIT_TESTS()
    CALL HELIX_UNIT_TESTS()
    CALL IMAGE_CTF_UNIT_TESTS()
    CALL FMC_UNIT_TESTS()
    CALL CTF_UNIT_TESTS()
    CALL COOS_UNIT_TESTS()
    CALL SPACE_CURVE_UNIT_TESTS()
    CALL IMAGE_BASE_UNIT_TESTS()
    CALL IMAGE_FFT_UNIT_TESTS()
    CALL FSC_UNIT_TESTS()
    CALL THREED_UNIT_TESTS()

    !CALL FMC_UNIT_TESTS()


END SUBROUTINE MODE_UNIT_TESTS_SLAVE

END MODULE MODE_UNIT_TESTS
